perf test: Add DWARF callchain conversion test

$ perf test -vv "DWARF callchain"
   87: perf inject to convert DWARF callchains to regular ones:
  --- start ---
  test child forked, pid 1560328
  recording data with DWARF callchain
  [ perf record: Woken up 4 times to write data ]
  [ perf record: Captured and wrote 0.908 MB /tmp/perf-test.nM3WoW (105 samples) ]
  convert DWARF callchain using perf inject
  compare the both result excluding inlined functions
  ---- end(0) ----
   87: perf inject to convert DWARF callchains to regular ones         : Ok
  $

Reviewed-by: Ian Rogers <irogers@google.com>
Signed-off-by: Namhyung Kim <namhyung@kernel.org>
Tested-by: Arnaldo Carvalho de Melo <acme@redhat.com>
Cc: Adrian Hunter <adrian.hunter@intel.com>
Cc: Ingo Molnar <mingo@kernel.org>
Cc: James Clark <james.clark@linaro.org>
Cc: Jiri Olsa <jolsa@kernel.org>
Cc: Peter Zijlstra <peterz@infradead.org>
Signed-off-by: Arnaldo Carvalho de Melo <acme@redhat.com>
This commit is contained in:
Namhyung Kim
2026-01-13 15:29:03 -08:00
committed by Arnaldo Carvalho de Melo
parent 92ea788d2a
commit b42c4dfe02

View File

@@ -0,0 +1,45 @@
#!/bin/bash
# perf inject to convert DWARF callchains to regular ones
# SPDX-License-Identifier: GPL-2.0
if ! perf check feature -q dwarf; then
echo "SKIP: DWARF support is not available"
exit 2
fi
TESTDATA=$(mktemp /tmp/perf-test.XXXXXX)
err=0
cleanup()
{
trap - EXIT TERM INT
rm -f ${TESTDATA}*
}
trap_cleanup()
{
cleanup
exit 1
}
trap trap_cleanup EXIT TERM INT
echo "recording data with DWARF callchain"
perf record -F 999 --call-graph dwarf -o "${TESTDATA}" -- perf test -w noploop
echo "convert DWARF callchain using perf inject"
perf inject -i "${TESTDATA}" --convert-callchain -o "${TESTDATA}.new"
perf report -i "${TESTDATA}" --no-children -q --percent-limit=1 > ${TESTDATA}.out
perf report -i "${TESTDATA}.new" --no-children -q --percent-limit=1 > ${TESTDATA}.new.out
echo "compare the both result excluding inlined functions"
if diff -u "${TESTDATA}.out" "${TESTDATA}.new.out" | grep "^- " | grep -qv "(inlined)"; then
echo "Found some differences"
diff -u "${TESTDATA}.out" "${TESTDATA}.new.out"
err=1
fi
cleanup
exit $err